<template>
    <div>
        <loading :active.sync="isLoading" :can-cancel="true" :is-full-page="fullPage"></loading>

        <div class="receber grey lighten-5" v-if="!isLoading">

            <v-container class="">
                <v-row justify="center" no-gutters>
                    <v-col md='2' class='force-scroll'>
                        <v-card class="pa-2" outlined tile>

                            <ListaPedidosReceber :pedidos="pedidos" />
                        </v-card>
                    </v-col>
                    <v-col>
                        <v-card class="pa-2" outlined tile>
                            <Pedido :pedidoSelecionado="pedidoSelecionado" :carrinhoSelecionado="carrinhoSelecionado"
                                :produtos="produtos" />
                        </v-card>
                    </v-col>
                    <v-col md='2' class="force-scroll">
                        <v-card class="pa-2" outlined tile>
                            <ListaPedidosBaixar :pedidos="pedidos" />
                        </v-card>
                    </v-col>
                </v-row>
            </v-container>

        </div>
    </div>
</template>

<style lang="scss">
    .force-scroll {
        overflow-y: scroll;
    }
</style>

<script>
    // @ is an alias to /src
    import ListaPedidosReceber from '@/components/ListaPedidosReceber.vue'
    import ListaPedidosBaixar from '@/components/ListaPedidosBaixar.vue'
    import Pedido from '@/components/Pedido.vue'
    import axios from 'axios';

    // Import Loading
    import Loading from 'vue-loading-overlay';
    import 'vue-loading-overlay/dist/vue-loading.css';

    axios.interceptors.response.use(
        function (response) {
            return response;
        },
        function (error) {
            console.log("error.response", error.response);
            return error.response;
        }
    );

    export default {
        name: 'Receber',
        provide() {
            return {
                getCarrinho: this.getCarrinho,
                zerosEsquerda: this.zerosEsquerda,
                getNomeProduto: this.getNomeProduto,
            };
        },
        components: {
            ListaPedidosReceber,
            ListaPedidosBaixar,
            Pedido,
            Loading,
        },
        data() {
            return {
                isLoading: false,
                fullPage: true,
                pedidos: {
                    dados: []
                },
                pedidoSelecionado: {
                    id: 0
                },
                // pedidosPendentesConcluidos: [],
                // pedidosPagos: [],
                // pedidosPendentes: [],
                // pedidosConcluidos: [],

                pedidoIniciado: {},
                pedidoBaixado: {},
                carrinhoSelecionado: {},
                produtos: {},
            }
        },
        created: function () {
            this.isLoading = true;
            let that = this;

            setTimeout(() => {
                that.isLoading = false
            }, 3000);
        },
        mounted: function () {
            this.getPedidos();
            this.getProdutos();
        },
        methods: {
            getPedidos: function () {
                console.log("Receber getPedidos");
                let url = 'http://localhost:8585/pedido';

                axios.get(url)
                    .then(response => {
                        this.pedidos = response.data;

                        this.pedidos.dados = this.pedidos.dados.slice().sort(function (a, b) {
                            return a.status_id - b.status_id;
                        });

                        this.selecionaProximoPedido();
                    })
                    .catch(error => this.erros = error.response);
            },
            getCarrinho: async function () {
                console.log("Receber getCarrinho");
                let url = 'http://localhost:8585/carrinho/' + this.pedidoSelecionado.id;
                let carrinhoRetorno = {};

                await axios.get(url)
                    .then(response => {
                        this.carrinhoSelecionado = response.data;
                        carrinhoRetorno = this.carrinhoSelecionado;
                    })
                    .catch(error => this.erros = error.response);

                return carrinhoRetorno;
            },
            getProdutos: function () {
                console.log("Receber getProdutos");
                let url = 'http://localhost:8585/produto';

                axios.get(url)
                    .then(response => {
                        this.produtos = response.data;
                    })
                    .catch(error => this.erros = error.response);
            },
            iniciarPedido: function (id, responsavel) {
                console.log("Receber iniciarPedido");
                let url = "http://localhost:8585/pedido/start";
                let dados = {
                    'id': id,
                    'responsavel': responsavel
                };

                axios.post(url, dados)
                    .then(response => {
                        this.pedidoIniciado = response.data;
                        this.getPedidos();
                        this.selecionaProximoPedido();
                    })
                    .catch(error => this.erros = error.response);
            },
            selecionaPedido: function (pedido) {
                console.log("Receber selecionaPedido");
                this.pedidoSelecionado = pedido;
            },
            selecionaProximoPedido: function () {

                this.pedidoSelecionado = this.pedidos.dados.filter(p => {
                    return p.status_id == 1
                })[0];
                if (this.pedidoSelecionado === undefined)
                    this.pedidoSelecionado = {
                        id: 0
                    };
                console.log("Receber selecionaProximoPedido", this.pedidoSelecionado);
            },
            baixarPedido: function (id) {
                console.log("Receber baixarPedido", id);
                let url = "http://localhost:8585/pedido/" + id;

                axios.put(url)
                    .then(response => {
                        this.pedidoBaixado = response.data;
                        this.getPedidos();
                    })
                    .catch(error => this.erros = error.response);
            },
            desbaixarPedido: function (id) {
                console.log("Receber desbaixarPedido", id);
                let url = "http://localhost:8585/pedido/giveback/" + id;

                axios.put(url)
                    .then(response => {
                        this.pedidoDevolvido = response.data;
                        this.getPedidos();
                    })
                    .catch(error => this.erros = error.response);
            },
            zerosEsquerda: function (numero) {
                numero = numero.toString();
                while (numero.length < 4)
                    numero = "0" + numero;
                return numero;                
            },
            getNomeProduto: function (id) {
                let prod = this.produtos.dados.find(p => p.id = id);
                return prod.nome;       
            }
        },
    }
</script>